﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;

namespace SynchronizedXamDataGrids
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ScrollViewer scrollViewer1;
        ScrollViewer scrollViewer2;

        public MainWindow()
        {
            InitializeComponent();
        }

        void LabelSizeChanged(object sender, SizeChangedEventArgs e)
        {
            xamDataGrid2.FieldLayouts[0].Fields[(sender as CellValuePresenter).Field.Name].Width = new FieldLength(e.NewSize.Width);      
        }

        void LabelSizeChanged2(object sender, SizeChangedEventArgs e)
        {            
            xamDataGrid1.FieldLayouts[0].Fields[(sender as CellValuePresenter).Field.Name].Width = new FieldLength(e.NewSize.Width);
        }

        private void xamDataGrid1_RecordFilterChanged(object sender, Infragistics.Windows.DataPresenter.Events.RecordFilterChangedEventArgs e)
        {
            RecordFilter rf = new RecordFilter();
            rf.FieldName = e.RecordFilter.FieldName;
            foreach (var item in e.RecordFilter.Conditions)
            {
                rf.Conditions.Add(item);
            }
            xamDataGrid2.FieldLayouts[0].RecordFilters.Add(rf);            
        }

        private void xamDataGrid2_RecordFilterChanged(object sender, Infragistics.Windows.DataPresenter.Events.RecordFilterChangedEventArgs e)
        {
            RecordFilter rf = new RecordFilter();
            rf.FieldName = e.RecordFilter.FieldName;
            foreach (var item in e.RecordFilter.Conditions)
            {
                rf.Conditions.Add(item);
            }
            xamDataGrid1.FieldLayouts[0].RecordFilters.Add(rf);
        }

        private void xamDataGrid1_FieldPositionChanged(object sender, Infragistics.Windows.DataPresenter.Events.FieldPositionChangedEventArgs e)
        {
            foreach (var item in xamDataGrid2.FieldLayouts[0].Fields)
            {
                item.ActualPosition = xamDataGrid1.FieldLayouts[0].Fields[item.Name].ActualPosition;                
            }
        }

        private void xamDataGrid2_FieldPositionChanged(object sender, Infragistics.Windows.DataPresenter.Events.FieldPositionChangedEventArgs e)
        {
            
            foreach (var item in xamDataGrid1.FieldLayouts[0].Fields)
            {
                item.ActualPosition = xamDataGrid2.FieldLayouts[0].Fields[item.Name].ActualPosition;
                //
                //HERE IS THE ADDED CODE
                //
                item.Visibility = xamDataGrid2.FieldLayouts[0].Fields[item.Name].Visibility;
                //
                //HERE IS THE NEW ADDED CODE
                //
                item.FixedLocation = xamDataGrid2.FieldLayouts[0].Fields[item.Name].FixedLocation;
            }
        }

        private void xamDataGrid1_Grouped(object sender, Infragistics.Windows.DataPresenter.Events.GroupedEventArgs e)
        {
            xamDataGrid2.FieldLayouts[0].SortedFields.Clear();
            foreach (var item in xamDataGrid1.FieldLayouts[0].SortedFields)
            {
                FieldSortDescription fsd = new FieldSortDescription();
                fsd.Direction = item.Direction;
                fsd.FieldName = item.FieldName;
                fsd.IsGroupBy = item.IsGroupBy;
                xamDataGrid2.FieldLayouts[0].SortedFields.Add(fsd);
            }
        }

        private void xamDataGrid1_Sorted(object sender, Infragistics.Windows.DataPresenter.Events.SortedEventArgs e)
        {
            xamDataGrid2.FieldLayouts[0].SortedFields.Clear();
            foreach (var item in xamDataGrid1.FieldLayouts[0].SortedFields)
	        {
                FieldSortDescription fsd = new FieldSortDescription();
                fsd.Direction = item.Direction;
                fsd.FieldName = item.FieldName;
                fsd.IsGroupBy = item.IsGroupBy;
                xamDataGrid2.FieldLayouts[0].SortedFields.Add(fsd);
	        }
            
        }

        private void xamDataGrid2_Grouped(object sender, Infragistics.Windows.DataPresenter.Events.GroupedEventArgs e)
        {
            xamDataGrid1.FieldLayouts[0].SortedFields.Clear();
            foreach (var item in xamDataGrid2.FieldLayouts[0].SortedFields)
            {
                FieldSortDescription fsd = new FieldSortDescription();
                fsd.Direction = item.Direction;
                fsd.FieldName = item.FieldName;
                fsd.IsGroupBy = item.IsGroupBy;
                xamDataGrid1.FieldLayouts[0].SortedFields.Add(fsd);
            }
        }

        private void xamDataGrid2_Sorted(object sender, Infragistics.Windows.DataPresenter.Events.SortedEventArgs e)
        {
            xamDataGrid1.FieldLayouts[0].SortedFields.Clear();
            foreach (var item in xamDataGrid2.FieldLayouts[0].SortedFields)
            {
                FieldSortDescription fsd = new FieldSortDescription();
                fsd.Direction = item.Direction;
                fsd.FieldName = item.FieldName;
                fsd.IsGroupBy = item.IsGroupBy;
                xamDataGrid1.FieldLayouts[0].SortedFields.Add(fsd);
            }
        }

        private void xamDataGrid1_Loaded(object sender, RoutedEventArgs e)
        {
            ScrollViewer viewer = (ScrollViewer)Utilities.GetDescendantFromType(xamDataGrid1,typeof(ScrollViewer),true);
            if (viewer != null)
            {
                scrollViewer1 = viewer;
                viewer.ScrollChanged += ScrollViewer_ScrollChanged;
            }
        }

        private void xamDataGrid2_Loaded(object sender, RoutedEventArgs e)
        {
            ScrollViewer viewer = (ScrollViewer)Utilities.GetDescendantFromType(xamDataGrid2, typeof(ScrollViewer), true);
            if (viewer != null )
            {
                scrollViewer2 = viewer;
                viewer.ScrollChanged += ScrollViewer_ScrollChanged;
            }
        }

        private void ScrollViewer_ScrollChanged(object sender, ScrollChangedEventArgs e)
        {
            if (e.HorizontalChange != 0)
            {
                if (sender == scrollViewer1)
                {
                    SetViewerOffset(scrollViewer2, e.HorizontalOffset);
                }
                else
                    SetViewerOffset(scrollViewer1, e.HorizontalOffset);
            }

        }

        private void SetViewerOffset(ScrollViewer viewer, double offset)
        {
            if (viewer.HorizontalOffset != offset)
                viewer.ScrollToHorizontalOffset(offset);
        }
    }
}
